import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

import org.basex.core.Context;
import org.basex.io.IOStream;
import org.basex.io.serial.Serializer;
import org.basex.query.QueryProcessor;
import org.basex.query.value.Value;
import org.basex.query.value.node.DBNode;

public class RunQuery {
  public static void main(String... args) throws Exception {
    // create context (only one per project!)
    Context ctx = new Context();
    
    String query = "xml/a";
    byte[] input = "<xml><a/></xml>".getBytes();
    InputStream is = new ByteArrayInputStream(input);
    
    try {
      // create context
      DBNode node = new DBNode(new IOStream(is));

      // run query, serialize result
      try(QueryProcessor qp = new QueryProcessor(query, ctx).context(node)) {
        // evaluate query
        Value result = qp.value();
        
        // output result as string
        OutputStream os = new ByteArrayOutputStream();
        Serializer ser = qp.getSerializer(os);
        result.serialize(ser);

        System.out.println("Result: " + os);

      }
    } finally {
      ctx.close();
    }
  }
}
